Bug 425201 - [SOLUTION] the firefox-1.5-pango-justified-range.patch breaks rasterization
[SOLUTION] the firefox-1.5-pango-justified-range.patch breaks rasterization
Status: CLOSED INSUFFICIENT_DATA
Product: Fedora
Classification: Fedora
Component: firefox (Show other bugs)
7
All Linux
medium Severity low
: ---
: ---
Assigned To: Gecko Maintainer
Fedora Extras Quality Assurance
firefox3INSUFFICIENT_DATAmassClosing
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-12-14 11:38 EST by Andy Shevchenko
Modified: 2008-08-02 19:40 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-04-09 10:05:03 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
Use justify alignment. (552 bytes, text/html)
2007-12-14 11:38 EST, Andy Shevchenko
no flags Details
Result with justify applied. (30.50 KB, application/octet-stream)
2007-12-14 11:39 EST, Andy Shevchenko
no flags Details
Clean version. (538 bytes, text/html)
2007-12-14 11:40 EST, Andy Shevchenko
no flags Details
PosScript result for clean version. (24.39 KB, application/octet-stream)
2007-12-14 11:41 EST, Andy Shevchenko
no flags Details

  None (edit)
Description Andy Shevchenko 2007-12-14 11:38:06 EST
Description of problem:
The construction with ALIGN="justify" does not correctly printed in the 
PostScript document (and on printer as well).

Version-Release number of selected component (if applicable):
All firefoxes with the applied firefox-1.5-pango-justified-range patch.

How reproducible:
Just see attachments and their comments.

Additional info:
Revert back the next line in the patch is solved issue.

>> //aRenderingContext.GetRangeWidth(top, aLength, offset, offset + 1, 
(PRUint32&)charWidth);
<< aRenderingContext.GetWidth(ch, charWidth);

P.S. The issue was tested on the Hebrew (UTF-8) HTML. The result the same as 
for russian/ukrainian.
Comment 1 Andy Shevchenko 2007-12-14 11:38:06 EST
Created attachment 289181 [details]
Use justify alignment.
Comment 2 Andy Shevchenko 2007-12-14 11:39:38 EST
Created attachment 289211 [details]
Result with justify applied.
Comment 3 Andy Shevchenko 2007-12-14 11:40:13 EST
Created attachment 289221 [details]
Clean version.
Comment 4 Andy Shevchenko 2007-12-14 11:41:09 EST
Created attachment 289231 [details]
PosScript result for clean version.
Comment 5 Christopher Aillon 2007-12-14 12:13:01 EST
Behdad, this is your patch... what do you think?
Comment 6 Behdad Esfahbod 2007-12-16 15:15:50 EST
It was actually Akira's patch.  CC'ing him.  I'll check it out tomorrow to see
if it's obviously wrong.
Comment 7 Behdad Esfahbod 2007-12-17 13:08:54 EST
(In reply to comment #0)
> Description of problem:
> The construction with ALIGN="justify" does not correctly printed in the 
> PostScript document (and on printer as well).
> 
> Version-Release number of selected component (if applicable):
> All firefoxes with the applied firefox-1.5-pango-justified-range patch.
> 
> How reproducible:
> Just see attachments and their comments.
> 
> Additional info:
> Revert back the next line in the patch is solved issue.
> 
> >> //aRenderingContext.GetRangeWidth(top, aLength, offset, offset + 1, 
> (PRUint32&)charWidth);
> << aRenderingContext.GetWidth(ch, charWidth);

The bug is with that "offset + 1" which assumes that the character there is one
byte.  It should be "offset + charWidth" I guess.  Can someone try that and
commit/build/whatever if it fixes the problem?  Thanks.

> P.S. The issue was tested on the Hebrew (UTF-8) HTML. The result the same as 
> for russian/ukrainian.
  
Comment 8 Behdad Esfahbod 2007-12-17 13:09:33 EST
There are three places in that patch that can use this fix.
Comment 9 Andy Shevchenko 2007-12-18 03:54:18 EST
(In reply to comment #7)
> The bug is with that "offset + 1" which assumes that the character there is 
one
> byte.  It should be "offset + charWidth" I guess.

As I understand correctly the charWidth isn't a multibyte length but the 
rendered width in the real pixels. So am I wrong?
Comment 10 Behdad Esfahbod 2008-01-02 18:00:31 EST
Oh is it?  In that case it needs more work.  I think that's the issue anyway,
the assumption that the char there is 1 unit.
Comment 11 Matěj Cepl 2008-02-21 17:34:33 EST
At this point, we're going to only be taking security fixes and major stability
fixes into this release of Fedora.  However, we still want to ensure the bug is
fixed in the next version.  We'd appreciate if you could test Firefox 3,
available at http://www.mozilla.com/en-US/firefox/all-beta.html or now shipping
as the default in Fedora rawhide and provide feedback as to whether it still
exists so we can file a ticket upstream to try to fix it in Firefox 3 before it
is released.
Comment 12 Matěj Cepl 2008-02-21 17:35:47 EST
At this point, we're going to only be taking security fixes and major stability
fixes into this release of Fedora.  However, we still want to ensure the bug is
fixed in the next version.  We'd appreciate if you could test Firefox 3,
available at http://www.mozilla.com/en-US/firefox/all-beta.html or now shipping
as the default in Fedora rawhide and provide feedback as to whether it still
exists so we can file a ticket upstream to try to fix it in Firefox 3 before it
is released.
Comment 13 Matěj Cepl 2008-04-09 10:05:03 EDT
Since there are insufficient details provided in this report for us to
investigate the issue further, and we have not received feedback to the
information we have requested above, we will assume the problem was not
reproducible, or has been fixed in one of the updates we have released for the
reporter's distribution.

Users who have experienced this problem are encouraged to upgrade to the latest
update of their distribution, and if this issue turns out to still be
reproducible in the latest update, please reopen this bug with additional
information.

Closing as INSUFFICIENT_DATA.

[This is a mass-closing request, if you think that this bug shouldn't be closed,
please, reopen with additional information.]

Note You need to log in before you can comment on or make changes to this bug.